Attribute VB_Name = "CiMiscFnc"
Option Explicit
'===================================================================
' This file is provided as part of the ClearImage COM Development Kit
'
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT
' WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,
' INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES
' OF MERCHANTABILITY AND/OR FITNESS FOR A  PARTICULAR PURPOSE.
'
' Copyright (C) 2003-2004.  Inlite Research, Inc. All rights reserved
'===================================================================

Public oCiServer As ClearImage.CiServer
Public oCiImage As CiImage

Private Declare Function GetSaveFileName Lib "comdlg32.dll" Alias _
         "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long
         
Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias _
         "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
         
Private Declare Function GetOpenFileNameW Lib "comdlg32.dll" _
         (pOpenfilename As OPENFILENAME) As Long


Private Declare Function GetSaveFileNameW Lib "comdlg32.dll" _
        (pOpenfilename As OPENFILENAME) As Long
         
Private Const OFN_READONLY = &H1
Private Const OFN_OVERWRITEPROMPT = &H2
Private Const OFN_HIDEREADONLY = &H4
Private Const OFN_NOCHANGEDIR = &H8
Private Const OFN_SHOWHELP = &H10
Private Const OFN_ENABLEHOOK = &H20
Private Const OFN_ENABLETEMPLATE = &H40
Private Const OFN_ENABLETEMPLATEHANDLE = &H80
Private Const OFN_NOVALIDATE = &H100
Private Const OFN_ALLOWMULTISELECT = &H200
Private Const OFN_EXTENSIONDIFFERENT = &H400
Private Const OFN_PATHMUSTEXIST = &H800
Private Const OFN_FILEMUSTEXIST = &H1000
Private Const OFN_CREATEPROMPT = &H2000
Private Const OFN_SHAREAWARE = &H4000
Private Const OFN_NOREADONLYRETURN = &H8000
Private Const OFN_NOTESTFILECREATE = &H10000
Private Const OFN_NONETWORKBUTTON = &H20000
Private Const OFN_NOLONGNAMES = &H40000                      '  force no long names for 4.x modules
Private Const OFN_EXPLORER = &H80000                         '  new look commdlg
Private Const OFN_NODEREFERENCELINKS = &H100000
Private Const OFN_LONGNAMES = &H200000                       '  force long names for 3.x modules

         
Private Type OPENFILENAME
  lStructSize As Long
  hwndOwner As Long
  hInstance As Long
  lpstrFilter As String
  lpstrCustomFilter As String
  nMaxCustFilter As Long
  nFilterIndex As Long
  lpstrFile As String
  nMaxFile As Long
  lpstrFileTitle As String
  nMaxFileTitle As Long
  lpstrInitialDir As String
  lpstrTitle As String
  flags As Long
  nFileOffset As Integer
  nFileExtension As Integer
  lpstrDefExt As String
  lCustData As Long
  lpfnHook As Long
  lpTemplateName As String
End Type
  
Public Const MB_PRO = 1
Public Const MB_PDF417 = 2
Public Const MB_DATAMATRIX = 3
Public Const MB_QR = 4

Public Sub ShowError(Optional sMsg = "")
  Dim str As String
  If Err.Number <> 0 Then
    If (sMsg <> "") Then str = sMsg & vbCrLf
    str = str & "Error from " & Err.Source & vbCrLf
    str = str & Err.Description & vbCrLf
    str = str & "HRESULT: " & "0x" & Hex$(Err.Number)
    MsgBox str
    Err.Clear
  End If
End Sub

Public Function FileOpenDialogA(sFileName As String) As String
  FileOpenDialogA = ""
  On Error GoTo except
  Dim OpenFile As OPENFILENAME
  Dim lReturn As Long
  Dim sFilter As String
  OpenFile.lStructSize = Len(OpenFile)
  OpenFile.hwndOwner = 0
  OpenFile.hInstance = App.hInstance
  sFilter = "Image Files (*.tif, *.jpg, *.bmp, *.pdf)" & Chr(0) & "*.tif;*.jpg;*.bmp;*.pdf" & Chr(0)
  sFilter = sFilter + "All Files (*.*)" & Chr(0) & "*.*" & Chr(0) & Chr(0)
  OpenFile.lpstrFilter = sFilter
  OpenFile.nFilterIndex = 1
  Dim sName: sName = sFileName
  OpenFile.lpstrFile = sName + String(1024 - Len(sName), 0)
  OpenFile.nMaxFile = Len(OpenFile.lpstrFile) - 1
  OpenFile.lpstrFileTitle = OpenFile.lpstrFile
  OpenFile.nMaxFileTitle = OpenFile.nMaxFile
  OpenFile.lpstrTitle = "Enter File Name"
  OpenFile.flags = 0
  lReturn = GetOpenFileName(OpenFile)
  If lReturn <> 0 Then ' 0 - Cancel was pressed
    FileOpenDialogA = OpenFile.lpstrFile
    FileOpenDialogA = StripNulls(FileOpenDialogA)
  End If
  Exit Function
except:
  ShowError "FOD"
End Function

Public Function FileOpenDialogW(sFileName As String) As String
  FileOpenDialogW = ""
  On Error GoTo except
  Dim OpenFile As OPENFILENAME
   
  Dim lReturn As Long
  Dim sFilter As String
  OpenFile.lStructSize = Len(OpenFile)
  OpenFile.hwndOwner = 0
  OpenFile.hInstance = App.hInstance
  sFilter = "Image Files (*.tif, *.jpg, *.bmp, *.pdf)" & Chr(0) & "*.tif;*.jpg;*.bmp;*.pdf" & Chr(0)
  sFilter = sFilter + "All Files (*.*)" & Chr(0) & "*.*" & Chr(0) & Chr(0)
  OpenFile.lpstrFilter = StrConv(sFilter, vbUnicode)
  OpenFile.nFilterIndex = 1
  Dim sName As String
  sName = sFileName
  OpenFile.lpstrFile = sName + String(1024 - Len(sName), 0)

  OpenFile.nMaxFile = Len(OpenFile.lpstrFile) - 1
  OpenFile.lpstrFileTitle = OpenFile.lpstrFile
  OpenFile.nMaxFileTitle = OpenFile.nMaxFile
  OpenFile.lpstrTitle = StrConv("Enter File Name", vbUnicode)
  OpenFile.flags = OFN_NOVALIDATE
  lReturn = GetOpenFileNameW(OpenFile)
  If lReturn <> 0 Then ' 0 - Cancel was pressed
     FileOpenDialogW = OpenFile.lpstrFile
  End If
  Exit Function
except:
  ShowError "FOD"
End Function

Public Function FileOpenDialog(sFileName As String) As String
  FileOpenDialog = FileOpenDialogW(sFileName)
End Function


Public Function StripNulls(sIn) As String
  StripNulls = sIn
  Dim ind: ind = InStr(sIn, Chr(0))
  If (ind > 0) Then StripNulls = Left(sIn, ind - 1)
End Function

Public Function SetExt(sIn, sExt) As String
  SetExt = sIn
  If (sExt = "") Then Exit Function
  Dim ind: ind = InStrRev(sIn, ".")
  If (ind = 0) Then
    SetExt = sIn & "." & sExt
  Else
    SetExt = Left(sIn, ind) & sExt
  End If
End Function

Public Function FileSaveDialogA(sFileName As String, Optional bAppend = False) As String
  FileSaveDialogA = ""
  On Error GoTo except
  Dim OpenFile As OPENFILENAME
  Dim lReturn As Long
  Dim sFilter As String
  OpenFile.lStructSize = Len(OpenFile)
  OpenFile.hwndOwner = 0
  OpenFile.hInstance = App.hInstance
  sFilter = sFilter + "TIF Files (*.tif)" & Chr(0) & "*.tif" & Chr(0)
  sFilter = sFilter + "PDF Files (*.pdf)" & Chr(0) & "*.pdf" & Chr(0)
  If (Not bAppend) Then
    sFilter = sFilter + "BMP Files (*.bmp)" & Chr(0) & "*.bmp" & Chr(0)
    sFilter = sFilter + "JPG Files (*.jpg)" & Chr(0) & "*.jpg" & Chr(0)
  End If
  sFilter = sFilter + "All Files (*.*)" & Chr(0) & "*.*" & Chr(0) & Chr(0)
  OpenFile.lpstrFilter = sFilter
  OpenFile.nFilterIndex = 1
  Dim sName: sName = sFileName
  OpenFile.lpstrFile = sName + String(1024 - Len(sName), 0)
  OpenFile.nMaxFile = Len(OpenFile.lpstrFile) - 1
  OpenFile.lpstrFileTitle = OpenFile.lpstrFile
  OpenFile.nMaxFileTitle = OpenFile.nMaxFile
  OpenFile.lpstrTitle = "Enter File Name"
  OpenFile.flags = 0 ' cdlOFNExplorer Or cdlOFNOverwritePrompt Or cdlOFNPathMustExist
  lReturn = GetSaveFileName(OpenFile)
  If lReturn <> 0 Then ' 0 - Cancel was pressed
    FileSaveDialogA = OpenFile.lpstrFile
    FileSaveDialogA = StripNulls(FileSaveDialogA)
    FileSaveDialogA = SetExt(FileSaveDialogA, Choose(OpenFile.nFilterIndex, "tif", "pdf", "bmp", "jpg", ""))
  End If
  Exit Function
except:
  ShowError "FSD"
End Function

Public Function FileSaveDialogW(sFileName As String, Optional bAppend = False) As String
  FileSaveDialogW = ""
  On Error GoTo except
  Dim OpenFile As OPENFILENAME
  Dim lReturn As Long
  Dim sFilter As String
  OpenFile.lStructSize = Len(OpenFile)
  OpenFile.hwndOwner = 0
  OpenFile.hInstance = App.hInstance
  sFilter = sFilter + "TIF Files (*.tif)" & Chr(0) & "*.tif" & Chr(0)
  sFilter = sFilter + "PDF Files (*.pdf)" & Chr(0) & "*.pdf" & Chr(0)
  If (Not bAppend) Then
    sFilter = sFilter + "BMP Files (*.bmp)" & Chr(0) & "*.bmp" & Chr(0)
    sFilter = sFilter + "JPG Files (*.jpg)" & Chr(0) & "*.jpg" & Chr(0)
  End If
  sFilter = sFilter + "All Files (*.*)" & Chr(0) & "*.*" & Chr(0) & Chr(0)
  OpenFile.lpstrFilter = StrConv(sFilter, vbUnicode)
  OpenFile.nFilterIndex = 1
  Dim sName: sName = sFileName
  OpenFile.lpstrFile = sName + String(1024 - Len(sName), 0)
  OpenFile.nMaxFile = Len(OpenFile.lpstrFile) - 1
  OpenFile.lpstrFileTitle = OpenFile.lpstrFile
  OpenFile.nMaxFileTitle = OpenFile.nMaxFile
  OpenFile.lpstrTitle = StrConv("Enter File Name", vbUnicode)
  OpenFile.flags = 0 ' cdlOFNExplorer Or cdlOFNOverwritePrompt Or cdlOFNPathMustExist
  lReturn = GetSaveFileNameW(OpenFile)
  If lReturn <> 0 Then ' 0 - Cancel was pressed
    FileSaveDialogW = OpenFile.lpstrFile
  End If
  Exit Function
except:
  ShowError "FSD"
End Function

Public Function FileSaveDialog(sFileName As String, Optional bAppend = False) As String
  FileSaveDialog = FileSaveDialogW(sFileName, bAppend)
End Function

Public Sub ShowRslt(sMsg)
  frmMain.txtResult = frmMain.txtResult & sMsg & vbCrLf
End Sub

Public Function RectToString(ByRef r) As String
  RectToString = r.Left & ":" & r.Top & "-" & r.Right & ":" & r.bottom
End Function

Public Function StringToHex(sIn As String, Optional bSaveAscii = False) As String
  Dim bInHex: bInHex = False
  Dim nPos, sOut, c, n As Integer: sOut = ""
  Dim cToBin, cFromBin:   cToBin = Chr(16): cFromBin = Chr(17)
  bInHex = Not bSaveAscii
  For nPos = 1 To Len(sIn)
    c = Mid(sIn, nPos, 1)
    n = Asc(c)
    If ((Not bSaveAscii) Or ((n < 32 Or n >= 127) And Not (n = 10 Or n = 13))) Then
      If (Not bInHex) Then sOut = sOut + cToBin
      bInHex = True
      sOut = sOut & IIf(n < 16, "0", "") & LCase(Hex(n)) & " "
    Else
      If (bInHex) Then sOut = sOut + cFromBin
      bInHex = False
      sOut = sOut + c
    End If
  Next
  StringToHex = sOut
End Function


Public Function CmbValue(ByRef cmb As ComboBox) As Long
  CmbValue = 0
  Dim n1, n2, stext
  n1 = InStr(cmb.Text, "[")
  n2 = InStr(cmb.Text, "]")
  If (n1 > 0 And n2 > n1) Then
    stext = Mid(cmb.Text, n1 + 1, n2 - n1 - 1)
    If (IsNumeric(stext)) Then
      CmbValue = CLng(stext)
    End If
  End If
End Function

Public Sub CmbSet(ByRef cmb As ComboBox)
  If (cmb.ListIndex = -1) Then cmb.ListIndex = 0
End Sub






