Attribute VB_Name = "CiTypeLib"
Option Explicit
'===================================================================
' This file is provided as part of the ClearImage COM Development Kit
'
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT
' WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,
' INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES
' OF MERCHANTABILITY AND/OR FITNESS FOR A  PARTICULAR PURPOSE.
'
' Copyright (C) 2003-2004.  Inlite Research, Inc. All rights reserved
'===================================================================

Private Function GetEnumName(ByRef X As TypeLibInfo, sEnum As String, nVal As Long, bFlags As Boolean)
  Dim r  As TypeInfo
  Dim m As MemberInfo
  GetEnumName = ""
  For Each r In X.TypeInfos
    If (r.TypeKind = TKIND_ENUM And LCase(r.Name) = LCase(sEnum)) Then
      For Each m In r.Members
        If (bFlags) Then
          If (GetEnumName <> "") Then GetEnumName = GetEnumName + " "
          If (m.Value And nVal) Then GetEnumName = GetEnumName + m.Name
        Else
          If (m.Value = nVal) Then GetEnumName = m.Name
        End If
      Next m
    End If
  Next r
End Function

Private Function GetEnumNameFromObject(ByRef o As Object, sEnum As String, nVal As Long, bFlags As Boolean)
  Dim t As InterfaceInfo
  Set t = InterfaceInfoFromObject(o)
  GetEnumNameFromObject = GetEnumName(t.Parent, sEnum, nVal, bFlags)
  Set t = Nothing
End Function

Private Function GetMemberTypeName(ByRef o As Object, sMember As String)
  GetMemberTypeName = ""
  Dim t As InterfaceInfo
  Set t = InterfaceInfoFromObject(o)
  Dim m As MemberInfo
  For Each m In t.Members
    If ((m.InvokeKind = INVOKE_PROPERTYGET) And (LCase(m.Name) = LCase(sMember))) Then
      GetMemberTypeName = m.ReturnType.TypeInfo.Name
    End If
  Next
  Set t = Nothing
End Function

'  Get text name of enumerated value from Type Library

Public Function Enum2Str(ByRef o As Object, sName, nVal, Optional bFlags = False)
  Dim sEName As String
  If (Left(sName, 1) = "$") Then
    sEName = Mid(sName, 2)
  Else
    sEName = GetMemberTypeName(o, CStr(sName))
  End If
  Enum2Str = GetEnumNameFromObject(o, CStr(sEName), CLng(nVal), CBool(bFlags))
End Function

