Attribute VB_Name = "RTBWriteModule"
Option Explicit

Private Const CP_UNICODE = 1200
Private Const WM_USER = &H400&
Private Const EM_SETTEXTEX = WM_USER + 97

Private Declare Function SendMessageWLng Lib "user32" Alias "SendMessageW" ( _
    ByVal hwnd As Long, _
    ByVal wMsg As Long, _
    ByVal wParam As Long, _
    ByVal lParam As Long) As Long
    
Public Enum RTBW_FLAGS
    'Flags for the SETEXTEX data structure.
    RTBW_DEFAULT = 0   'Deletes undo stack, discards RTF formatting, replaces all text.
    RTBW_KEEPUNDO = 1  'Keeps undo stack.
    RTBW_SELECTION = 2 'Replaces selection and keeps RTF formatting.
End Enum
'Force IDE to maintain the case of these constant names.
#If False Then
Dim RTBW_DEFAULT
Dim RTBW_KEEPUNDO
Dim RTBW_SELECTION
#End If

Private Type SETTEXTEX
    flags As RTBW_FLAGS
    codepage As Long
End Type

Public Sub RTBWriteUnicode( _
    ByRef RTB As RichTextLib.RichTextBox, _
    ByRef Text As String, _
    Optional ByVal flags As RTBW_FLAGS = RTBW_DEFAULT)
    'Writes Text to RichTextBox as Unicode text on a system with Rich Edit 3.0
    '(Windows Me, Windows 2000, or later).
    '
    'Caution/Feature:
    '   If Text begins with a valid RTF sequence such as "{\rtf" or "{urtf" the
    '   text is taken as RTF instead of plain text.
    Dim stUnicode As SETTEXTEX
    
    With stUnicode
        .flags = flags
        .codepage = CP_UNICODE
    End With
    If SendMessageWLng(RTB.hwnd, EM_SETTEXTEX, VarPtr(stUnicode), StrPtr(Text)) = 0 Then
        Err.Raise &H4008AA00, "WriteUnicodeText", "Failed: insufficient space available"
    End If
End Sub

Public Function FileNameToHex(sIn As String) As String
  Dim nPos, sOut, c, n As Integer: sOut = ""
  For nPos = 1 To Len(sIn)
    c = Mid(sIn, nPos, 1)
    n = Asc(c)
    sOut = sOut & IIf(n < 16, "0", "") & LCase(Hex(n)) ' & " "
  Next
  FileNameToHex = "|||" & sOut
End Function

Public Function FileNameFromHex(sIn1 As String) As String
  FileNameFromHex = ""
  If (Left(sIn1, 3) <> "|||") Then Exit Function
  sIn1 = Mid(sIn1, 4)
  Dim sOut As String, n, n1, n2, sIn As String
  Dim sHex As String: sHex = "0123456789ABCDEF"
  sIn = UCase(sIn1)
  For n = 1 To Len(sIn) - 1 Step 2
    n1 = InStr(sHex, Mid(sIn, n, 1))
    n2 = InStr(sHex, Mid(sIn, n + 1, 1))
    If (n1 = 0) Or (n2 = 0) Then
      Exit Function
    End If
    sOut = sOut + Chr((n1 - 1) * 16 + (n2 - 1))
  Next
  FileNameFromHex = sOut
End Function

